<html>
<head>
<title>OgreOverlayContainer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreOverlayContainer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreOverlayContainer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OverlayContainer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OverlayContainer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreOverlayElement_8h.html">OgreOverlayElement.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00056"></a><a class="code" href="classOgre_1_1OverlayContainer.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1OverlayContainer.html#add1fecc24f10c5b2a171ddab9474e8f0">00059</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, OverlayElement*&gt;::type</a> <a class="code" href="classOgre_1_1OverlayContainer.html#add1fecc24f10c5b2a171ddab9474e8f0">ChildMap</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1OverlayContainer.html#aab02a8f87528fb846039ef718b4d3ba8">00060</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ChildMap&gt;</a> <a class="code" href="classOgre_1_1OverlayContainer.html#aab02a8f87528fb846039ef718b4d3ba8">ChildIterator</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1OverlayContainer.html#aa643f26295580a54eaadf5d54328339a">00061</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, OverlayContainer*&gt;::type</a> <a class="code" href="classOgre_1_1OverlayContainer.html#aa643f26295580a54eaadf5d54328339a">ChildContainerMap</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a000e571565ca93dc4ec617a32f632946">00062</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ChildContainerMap&gt;</a> <a class="code" href="classOgre_1_1OverlayContainer.html#a000e571565ca93dc4ec617a32f632946">ChildContainerIterator</a>;
<a name="l00063"></a>00063     <span class="keyword">protected</span>:
<a name="l00064"></a>00064         <span class="comment">// Map of all children</span>
<a name="l00065"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a9c9338f2d946c78e816d26684a193693">00065</a>         <a class="code" href="classOgre_1_1OverlayContainer.html#add1fecc24f10c5b2a171ddab9474e8f0">ChildMap</a> <a class="code" href="classOgre_1_1OverlayContainer.html#a9c9338f2d946c78e816d26684a193693">mChildren</a>;
<a name="l00066"></a>00066         <span class="comment">// Map of container children (subset of mChildren)</span>
<a name="l00067"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a72d4dd60569a63cf1a8fae2513fdd0d6">00067</a>         <a class="code" href="classOgre_1_1OverlayContainer.html#aa643f26295580a54eaadf5d54328339a">ChildContainerMap</a> <a class="code" href="classOgre_1_1OverlayContainer.html#a72d4dd60569a63cf1a8fae2513fdd0d6">mChildContainers</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a9e9b3a0199a4d6e8549ce4e98147473b">00069</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayContainer.html#a9e9b3a0199a4d6e8549ce4e98147473b">mChildrenProcessEvents</a>;
<a name="l00070"></a>00070  
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00074"></a>00074         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>();
<a name="l00075"></a>00075 
<a name="l00077"></a>00077         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addChild(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* elem);
<a name="l00079"></a>00079         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addChildImpl(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* elem);
<a name="l00081"></a>00081         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addChildImpl(<a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* cont);
<a name="l00083"></a>00083         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* getChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00086"></a>00086 
<a name="l00088"></a>00088         <span class="keywordtype">void</span> initialise(<span class="keywordtype">void</span>);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <span class="keywordtype">void</span> _addChild(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* elem);
<a name="l00091"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a1c4711038030d7464ca3c2b60c380175">00091</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OverlayContainer.html#a1c4711038030d7464ca3c2b60c380175">_removeChild</a>(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* elem) { <a class="code" href="classOgre_1_1OverlayContainer.html#a1c4711038030d7464ca3c2b60c380175">_removeChild</a>(elem-&gt;<a class="code" href="classOgre_1_1OverlayElement.html#ab795d381673362bc456544706609e32f" title="Gets the name of this overlay.">getName</a>()); }
<a name="l00092"></a>00092         <span class="keywordtype">void</span> _removeChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <span class="keyword">virtual</span> ChildIterator getChildIterator(<span class="keywordtype">void</span>);
<a name="l00096"></a>00096 
<a name="l00101"></a>00101         <span class="keyword">virtual</span> ChildContainerIterator getChildContainerIterator(<span class="keywordtype">void</span>);
<a name="l00102"></a>00102 
<a name="l00104"></a>00104         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _positionsOutOfDate(<span class="keywordtype">void</span>);
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _update(<span class="keywordtype">void</span>);
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> _notifyZOrder(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> newZOrder);
<a name="l00111"></a>00111 
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyViewport();
<a name="l00114"></a>00114 
<a name="l00116"></a>00116         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyWorldTransforms(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform);
<a name="l00117"></a>00117 
<a name="l00119"></a>00119         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParent(<a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* parent, <a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &#39;normal&#39; scene contents.">Overlay</a>* overlay);
<a name="l00120"></a>00120 
<a name="l00122"></a>00122         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1OverlayContainer.html#a9097791d07dab9e4dccf4282ec3e3607">00125</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isContainer()<span class="keyword"> const</span>
<a name="l00126"></a>00126 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00127"></a>00127 
<a name="l00129"></a><a class="code" href="classOgre_1_1OverlayContainer.html#adc85e70102a0b27a6cdaae652002e1ac">00129</a>         <span class="keyword">virtual</span> <span class="keyword">inline</span> <span class="keywordtype">bool</span> isChildrenProcessEvents()<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00131"></a>00131 
<a name="l00133"></a><a class="code" href="classOgre_1_1OverlayContainer.html#acc3dbfd57c14ce83efcc89c22ef621b7">00133</a>         <span class="keyword">virtual</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> setChildrenProcessEvents(<span class="keywordtype">bool</span> val)
<a name="l00134"></a>00134         { mChildrenProcessEvents = val; }
<a name="l00135"></a>00135 
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* findElementAt(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y);      <span class="comment">// relative to parent</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> copyFromTemplate(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* templateOverlay);
<a name="l00140"></a>00140         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142     };
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
